#This script will clean up files that don't have track identifiers, insert the header and do a save as.
#The only difference between this script and the GDTagfileIsolateTrackNames scipt is that the last line in Part 1
#"Find all the lines that match the various track numbering schemes" is commented out.

#This script will isolate just the track names from the file, one track name per line

#Part 1
#Import the regular expression module, if needed (remove the #):
from Npp import*
import re
#set the starting position to line 1:
editor.gotoLine(1)
#Remove unwanted extraneous characters from song names
editor.replace('1/2', 'Half')
editor.rereplace('"|;|\+|/+|\*+|\%|\@', '')
#editor.rereplace('|\|/|\*|\%|\@', '')
editor.replace('>>', '>')
#Remove 'Encore'
editor.rereplace('Encore\W*\s*', ''), re.IGNORECASE
#Find all the lines that match the various track numbering schemes, and delete everything except for those lines (replace with nothing - '')
#editor.rereplace('(?!^.*(^\d*\W*d\d+\W*t*\d*\W*\d*\:*\d*\W*)|(^\d*\W*s\d+t\d+\W*\d*\:*\d*\W*)|(^\s*\.*\d+\s*\)*\.*\:*\-*\s*\-*\s*(?=[A-Z]|[a-z]))|(^\d+\.*\s+\[\d+\:\d+\]\s*)|(^\d+\s+\d+\:\d+\s*).*$)^.+', '')
#editor.rereplace('(?!^.*insert_pattern_here.*$)^.+', '')

#Part 2
#Find all the blank lines and delete them:
editor.rereplace('[\r\n]{2,}', '\r\n')
#Find all the track numbering characters and replace them with nothing ('')
#This one is old:
editor.rereplace('(^\d*\W*d\d+\W*t*\d*\W*\d*\:*\d*\W*)|(^\d*\W*s\d+t\d+\W*\d*\:*\d*\W*)|(^\s*\.*\d+\s*\)*\.*\:*\-*\s*\-*\s*(?=[A-Z]|[a-z]))|(^\d+\.*\s+\[\d+\:\d+\]\s*)|(^\d+\s+\d+\:\d+\s*)|', '')
editor.rereplace('\s*\-*\s*\[*\(*\d+\:\d+\)*\]*', '')
notepad.runMenuCommand('Blank Operations', 'Trim Leading And Trailing Space')
notepad.runMenuCommand('Line Operations', 'Remove Empty Lines')
#notepad.runMenuCommand('Select All')
#notepad.runMenuCommand('TextFX Characters', 'Proper Case')

#Part 3
# -> to >
editor.rereplace('\s*[-]*->', '>')
#And to &, for example Around And Around to Around & Around, etc.  Needs to be improve to not match all 'and' including in the word Band, etc.
#editor.replace('and', '&'), re.IGNORECASE
#Abbreviated and short names > proper names
editor.replace('Playin\'', 'Playing')
editor.replace('BIODTL','Beat It On Down The Line')
editor.rereplace('Tenn\.* Jed|TN\.* Jed', 'Tennessee Jed')
editor.replace('MAMU', 'Me & My Uncle')
editor.replace('TOO', 'The Other One')
editor.replace('WRS', 'Weather Report Suite')
editor.replace('GDTRFB', 'Going Down The Road Feeling Bad')
editor.replace('NFA', 'Not Fade Away')
editor.replace('OMSN', 'One More Saturday Night')
editor.replace('UJB', 'Uncle John\'s Band')
editor.replace('SOTM', 'Standing On The Moon')
editor.replace('BEW', 'Brown Eyed Women')
editor.rereplace('B[\.]E[\.] Women', 'Brown Eyed Women')
editor.replace('CR & S', 'Cold Rain And Snow')
editor.replace('TLEO', 'They Love Each Other')
editor.replace('B.T. Wind', 'Black Throated Wind')
editor.replace('BT Wind', 'Black Throated Wind')
editor.replace('BTW', 'Black Throated Wind')
editor.replace('GSET', 'Greatest Story Ever Told')
editor.replace('PITB', 'Playing In The Band')
editor.replace('A & A', 'Around & Around')
editor.replace('IMHBTR', 'It Must Have Been The Roses')
editor.rereplace('China \-*> Rider', 'China Cat Sunflower > I Know You Rider')
editor.replace('12 Step', 'Mississippi Half Step Uptown Toodeloo')
editor.replace('FOTD', 'Friend Of The Devil')
editor.replace('JBG', 'Johnny B. Goode')
editor.rereplace('L\.*L\.* Rain', 'Looks Like Rain')
#short names of GD Songs. These need improvement to not match full names:
editor.rereplace('China\s*-*>*\s*\r|China Cat\s*-*>*\s*\r(?!(\sCat Sunflower))', 'China Cat Sunflower >', re.IGNORECASE)
editor.rereplace('(?<!I Know You)^Rider', 'I Know You Rider', re.IGNORECASE)
editor.rereplace('^Mexicali\s*\r(?!\s*Blues)', 'Mexicali Blues', re.IGNORECASE)
editor.rereplace('^Around\s*\r(?!\& Around)', 'Around & Around', re.IGNORECASE)
editor.rereplace('eyes\s*-*>*\s*\r(?!\s*of the world)', 'Eyes Of The World >', re.IGNORECASE)
editor.rereplace('Sugar Mag[s]*\r(?!nolia[s]*)', 'Sugar Magnolia', re.IGNORECASE)
#editor.rereplace('playin\'*\s*-*>*\s*\r(?!\s*in the band)', 'Playin\' In The Band', re.IGNORECASE) #may need to remove the escape (\) before the ' for this to work
editor.rereplace('playing\r*(?!\s*in the band)', 'Playing In The Band', re.IGNORECASE)
editor.rereplace('^Terrapin\s*\r(?!\s*Station)', 'Terrapin Station'), re.IGNORECASE
editor.rereplace('^Scarlet\s*\r(?!\s*Begonias)', 'Scarlet Begonias'), re.IGNORECASE
editor.rereplace('^Fire\s*\r(?!\s*On The Mountain)', 'Fire On The Mountain'), re.IGNORECASE
editor.rereplace('^Half\-*\s*Step\s*\r(?!\s*Uptown Toodeloo)', 'Mississippi Half-Step Uptown Toodeloo'), re.IGNORECASE
editor.rereplace('(?<!One More)^Saturday Night', 'One More Saturday Night'), re.IGNORECASE
editor.rereplace('^Greatest[ Story]*\r(?!\s*Ever Told)', 'Greatest Story Ever Told'), re.IGNORECASE
#editor.rereplace('^Greatest(?!\s*Story Ever Told)', 'Greatest Story Ever Told'), re.IGNORECASE
editor.rereplace('^Don\'t Ease\s*\r(?!\s*Me In)', 'Don\'t Ease Me In'), re.IGNORECASE
editor.rereplace('^Promised\s*\r(?!\s*Land)', 'Promised Land'), re.IGNORECASE
editor.rereplace('(?<!It Must Have Been The)^Roses', 'It Must Have Been The Roses'), re.IGNORECASE
editor.rereplace('Playin\r*(?!g In The Band)', 'Playing In The Band', re.IGNORECASE)
editor.rereplace('^Dancin[g*\'*]*\s*\r(?!\s*In The Streets)', 'Dancin\' In The Streets'), re.IGNORECASE
editor.rereplace('^Help\s*\r(?!\s*On The Way)', 'Help On The Way'), re.IGNORECASE
editor.rereplace('^Samson\s*\r', 'Samson & Delilah'), re.IGNORECASE
editor.rereplace('^Minglewood\s*\r(?!\s*Blues)', 'Minglewood Blues'), re.IGNORECASE

#tuning > -----tuning-----
editor.rereplace('^tuning', '-----tuning-----', re.IGNORECASE)
#Remove unwanted extraneous characters from song names
#editor.rereplace('"|\|/|\*|\%|\@', '') #These were moved towards the top
# Dark Star> to Dark Star >
editor.rereplace('(?<!\s)>', ' >')
#editor.rereplace('\s+\>', ' >')
# Dark Star> to Dark Star >
#editor.rereplace('(?<=\w)>', ' >')
#Truckin' >MLBJ >Spanish Jam > > Truckin' > MLBJ > Spanish Jam >
#editor.rereplace('>(?=\w)', '> ')
#Remove Encore notifications such as E: One More Satruday Night
editor.rereplace('^E\W\s*', ''), re.IGNORECASE

#Part 4
#This creates a function called pasteHeader, which goes to the first position in each line, pastes the contents of the clipboard, 
#then goes to the next line down. It does that for each line.
def pasteHeader(contents, lineNumber, totalLines):
	#editor.goToLine(1)
	editor.home()
	editor.paste()
	editor.lineDown()
#	return 0	
	
editor.forEachLine(pasteHeader)

#Get the current file name, add " tagfile.txt" to it and do a "save as"
newFilename = notepad.getCurrentFilename() + " tagfile.txt"
notepad.saveAs(newFilename)